# file: pi.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# The Monte Carlo Method for approximating pi.
#
# The idea is to generate N random points in the unit square. Those
# within a distance of 1 from the origin fall within the upper right
# quarter of a unit circle. For sufficiently large N, we expect pi/4
# of them to fall within the quartercircle.
#
# NB: THIS CODE IS LEFT WITH AN ERROR INTENTIONALLY. CAN YOU SPOT IT?
#
import random, math

def approxPi(n):
  def repeat(i, inside):
    if i > n:
      return inside / n * 4
    else:
      x = random.random()
      y = random.random()
      if math.sqrt(x ** 2.0 + y ** 2.0) < 1.0:
        return repeat(i + 1, inside + 1)
      else:
        return repeat(i + 1, inside)
  return repeat(1, 0)

  
