# file: isPrime.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
import math

# isFactor : int * int -> bool
#
def isFactor(m, n): return n % m == 0

# isPrime : int -> bool
# 
# The call isPrime(n) returns True if n is prime and False otherwise.
#
def isPrime(n):
    top = math.sqrt(n)
    def repeat(m):
        if m > top:
            return True
        elif isFactor(m, n):
            return False
        else:
            return repeat(m + 1)
    repeat 2
